#include "Product.h"
#include <fstream>


std::istream& operator >>(std::istream& in, product& ware) {
    std::string buf;
    std::cout << "Warehouse number: ";
    in >> ware.number;
    std::cout << "Record code:";
    in >> ware.code;
    std::cout << "Name: ";
    in >> ware.name;
    std::cout << "Record creation date: ";
    in >> ware.date;
    std::cout << "Expiration (days): ";
    in >> ware.expiration;
    std::cout << "Amount: ";
    in >> ware.amount;
    std::cout << "Price for one: ";
    in >> ware.price_for_one;
    return in;
}

std::ostream& operator <<(std::ostream& out, product& ware) {
    out <<
        "Item number: " << ware.number << std::endl <<
        "Item code: " << ware.code << std::endl <<
        "Item Name: " << ware.name << std::endl <<
        "Item start date: " << ware.date << std::endl <<
        "Expiration days: " << ware.expiration << std::endl <<
        "Amount: " << ware.amount << std::endl <<
        "Price for one: " << ware.price_for_one << std::endl;
    return out;
}


void mainClass::load_in()
{
    records_map.clear();
    s = 0;
    std::ifstream in;
    in.open("records.bin", std::ios::binary);
    if (!in.is_open())
        return;
    product cur;
    char* p = reinterpret_cast<char*>(&cur);
    while (in.read(p, sizeof(product)))
    {
        s++;
        records_map.insert({ s, cur });
    }
    in.close(); //!!! Файл и так закрывается деструктором 
}

void mainClass::load_out()
{
    std::ofstream out("records.bin", std::ios::binary);
    std::map<size_t, product>::iterator iter = records_map.begin();

    while (iter != records_map.end())
    {
        out.write(reinterpret_cast<char*>(&iter->second), sizeof(product));
        iter++;
    }
    out.close();
}

mainClass::mainClass()
{
    load_in();
}

mainClass::~mainClass()
{
    load_out();
    records_map.clear();
}


void mainClass::add_record(product& p)
{
    s++;
    std::pair<size_t, product> c_p(s, p);
    records_map.insert(c_p);
    load_out();
}

bool mainClass::search_record_number(const int p)
{
    auto res = std::find_if(records_map.begin(), records_map.end(), [&p](const std::pair<size_t, product>& p2)
        {
            return p2.second.expiration == p;
        });
    if (res == records_map.end())
    {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != records_map.end())
    {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(product));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, records_map.end(), [&p](const std::pair<size_t, product>& p2)
            {
                return p2.second.expiration == p;
            });
    }
    fout.close();
    return true;
}

bool mainClass::search_record_code(const int p)
{
    auto res = std::find_if(records_map.begin(), records_map.end(), [&p](const std::pair<size_t, product>& p2)
        {
            return p2.second.code == p;
        });
    if (res == records_map.end())
    {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != records_map.end())
    {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(product));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, records_map.end(), [&p](const std::pair<size_t, product>& p2)
            {
                return p2.second.code == p;
            });
    }
    fout.close();
    return true;
}

bool mainClass::search_record_date(const std::string& p)
{
    auto res = std::find_if(records_map.begin(), records_map.end(), [&p](const std::pair<size_t, product>& p2)
        {
            return p2.second.date == p;
        });
    if (res == records_map.end())
    {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != records_map.end())
    {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(product));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, records_map.end(), [&p](const std::pair<size_t, product>& p2)
            {
                return p2.second.date == p;
            });
    }
    fout.close();
    return true;
}

bool mainClass::search_expiration(const int p)
{
    auto res = std::find_if(records_map.begin(), records_map.end(), [&p](const std::pair<size_t, product>& p2)
        {
            return p2.second.expiration == p;
        });
    if (res == records_map.end())
    {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != records_map.end())
    {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(product));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, records_map.end(), [&p](const std::pair<size_t, product>& p2)
            {
                return p2.second.expiration == p;
            });
    }
    fout.close();
    return true;
}


bool mainClass::delete_record(const product& p)
{
    auto res = std::find_if(records_map.begin(), records_map.end(), [&p](const std::pair<size_t, product>& p2)
        {
            return p2.second == p;
        });
    if (res == records_map.end())
    {
        return false;
    }
    while (res != records_map.end())
    {
        res = records_map.erase(res);
        s--;
        res = std::find_if(res, records_map.end(), [&p](const std::pair<size_t, product>& p2)
            {
                return p2.second == p;
            });
    }
    load_out();
    return true;
}

bool mainClass::change_record(const product& rec1, const product& rec2)
{
    auto res = std::find_if(records_map.begin(), records_map.end(), [&rec1](const std::pair<size_t, product>& p2)
        {
            return p2.second == rec1;
        });
    if (res == records_map.end())
    {
        return false;
    }
    while (res != records_map.end())
    {
        res->second = rec2;
        s--;
        res = std::find_if(res, records_map.end(), [&rec1](const std::pair<size_t, product>& p2)
            {
                return p2.second == rec1;
            });
    }
    load_out();
    return true;
}


void mainClass::load_out_txt()
{
    auto iter = records_map.begin();

    std::ofstream txt_out("Load_out.txt");

    txt_out << std::setw(15) <<
        "Account number" << "|" << std::setw(15) <<
        "Account code" << "|" << std::setw(15) <<
        "Name" << "|" << std::setw(15) <<
        "Record creation date" << "|" << std::setw(15) <<
        "Expiration" << "|" << std::setw(25) <<
        "Amount" << "|" << std::setw(25) <<
        "Price for one" << std::endl << std::string(107, '-') << std::endl;


    while (iter != records_map.end())
    {
        txt_out << std::setw(15) <<
            iter->second.number << "|" << std::setw(15) <<
            iter->second.code << "|" << std::setw(15) <<
            iter->second.date << "|" << std::setw(15) <<
            iter->second.name << "|" << std::setw(15) <<
            iter->second.expiration << "|" << std::setw(25) <<
            iter->second.amount << "|" << std::setw(15) <<
            iter->second.price_for_one << std::endl;
        iter++;
    }

    txt_out.close();
}
